/* =========================================================

// jquery.innerfade.js

// Datum: 2008-02-14
// Firma: Medienfreunde Hofmann & Baldes GbR
// Author: Torsten Baldes
// Mail: t.baldes@medienfreunde.com
// Web: http://medienfreunde.com

// based on the work of Matt Oakes http://portfolio.gizone.co.uk/applications/slideshow/
// and Ralf S. Engelschall http://trainofthoughts.org/

 *
 *  <ul id="news"> 
 *      <li>content 1</li>
 *      <li>content 2</li>
 *      <li>content 3</li>
 *  </ul>
 *  
 *  xoops_smallworld('#news').innerfade({ 
 *	  animationtype: Type of animation 'fade' or 'slide' (Default: 'fade'), 
 *	  speed: Fading-/Sliding-Speed in milliseconds or keywords (slow, normal or fast) (Default: 'normal'), 
 *	  timeout: Time between the fades in milliseconds (Default: '2000'), 
 *	  type: Type of slideshow: 'sequence', 'random' or 'random_start' (Default: 'sequence'), 
 * 		containerheight: Height of the containing element in any css-height-value (Default: 'auto'),
 *	  runningclass: CSS-Class which the container gets applied (Default: 'innerfade'),
 *	  children: optional children selector (Default: null)
 *  }); 
 *

// ========================================================= */


(function (xoops_smallworld) {

    xoops_smallworld.fn.innerfade = function (options) {
        return this.each(function () {
            xoops_smallworld.innerfade(this, options);
        });
    };

    xoops_smallworld.innerfade = function (container, options) {
        var settings = {
            'animationtype': 'fade',
            'speed': 'normal',
            'type': 'sequence',
            'timeout': 2000,
            'containerheight': 'auto',
            'runningclass': 'innerfade',
            'children': null
        };
        if (options)
            xoops_smallworld.extend(settings, options);
        if (settings.children === null)
            var elements = xoops_smallworld(container).children();
        else
            var elements = xoops_smallworld(container).children(settings.children);
        if (elements.length > 1) {
            xoops_smallworld(container).css('position', 'relative').css('height', settings.containerheight).addClass(settings.runningclass);
            for (var i = 0; i < elements.length; i++) {
                xoops_smallworld(elements[i]).css('z-index', String(elements.length - i)).css('position', 'absolute').hide();
            }
            if (settings.type == "sequence") {
                setTimeout(function () {
                    xoops_smallworld.innerfade.next(elements, settings, 1, 0);
                }, settings.timeout);
                xoops_smallworld(elements[0]).show();
            } else if (settings.type == "random") {
                var last = Math.floor(Math.random() * (elements.length));
                setTimeout(function () {
                    do {
                        current = Math.floor(Math.random() * (elements.length));
                    } while (last == current);
                    xoops_smallworld.innerfade.next(elements, settings, current, last);
                }, settings.timeout);
                xoops_smallworld(elements[last]).show();
            } else if (settings.type == 'random_start') {
                settings.type = 'sequence';
                var current = Math.floor(Math.random() * (elements.length));
                setTimeout(function () {
                    xoops_smallworld.innerfade.next(elements, settings, (current + 1) % elements.length, current);
                }, settings.timeout);
                xoops_smallworld(elements[current]).show();
            } else {
                alert('Innerfade-Type must either be \'sequence\', \'random\' or \'random_start\'');
            }
        }
    };

    xoops_smallworld.innerfade.next = function (elements, settings, current, last) {
        if (settings.animationtype == 'slide') {
            xoops_smallworld(elements[last]).slideUp(settings.speed);
            xoops_smallworld(elements[current]).slideDown(settings.speed);
        } else if (settings.animationtype == 'fade') {
            xoops_smallworld(elements[last]).fadeOut(settings.speed);
            xoops_smallworld(elements[current]).fadeIn(settings.speed, function () {
                removeFilter(xoops_smallworld(this)[0]);
            });
        } else
            alert('Innerfade-animationtype must either be \'slide\' or \'fade\'');
        if (settings.type == "sequence") {
            if ((current + 1) < elements.length) {
                current = current + 1;
                last = current - 1;
            } else {
                current = 0;
                last = elements.length - 1;
            }
        } else if (settings.type == "random") {
            last = current;
            while (current == last)
                current = Math.floor(Math.random() * elements.length);
        } else
            alert('Innerfade-Type must either be \'sequence\', \'random\' or \'random_start\'');
        setTimeout((function () {
            xoops_smallworld.innerfade.next(elements, settings, current, last);
        }), settings.timeout);
    };

})(jQuery);

// **** remove Opacity-Filter in ie ****
function removeFilter(element) {
    if (element.style.removeAttribute) {
        element.style.removeAttribute('filter');
    }
}
